/*
russian roulette

By Tom.C aka ErUs
Ported to pz2 by Armon Khosravi aka miz dawg

Made in one night :D
*/
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <errno.h>
#include "pz.h"

#define SCRW ttk_screen->w
#define SCRH (ttk_screen->h - ttk_screen->wy)

#define PLAYERCPU 0
#define PLAYERHUM 1

enum { PICKPLAYERS, PICKDANGER, PLAYERONE, PLAYERTWO, RESCLICK, RESBANG, ENDRESULT } ;

static PzModule *module;
static PzWidget *wid;

static int gamestate;
int currentturn;

static int players;
static int livebullets;
static ttk_surface image;
static int w, h;

void DrawWnd(PzWidget *wid, ttk_surface srf) 
{
  char buff[33]; /* super fix 5000! */

	ttk_fillrect (srf, 0, 0, SCRW, SCRH, ttk_makecol(WHITE));

	switch( gamestate ) {
	case PICKPLAYERS:
		ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "Choose your opponent:");
		if( players == PLAYERCPU ) {
			ttk_text(srf, ttk_menufont, 10, 30, ttk_ap_getx("window.fg")->color, "CPU player opponent");
		} else {
			ttk_text(srf, ttk_menufont, 10, 30, ttk_ap_getx("window.fg")->color, "Human player opponent");
			ttk_text(srf, ttk_menufont, 10, 50, ttk_ap_getx("window.fg")->color, "(Two player game)");
		}
		
		break;
	case PICKDANGER:
		ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "Choose the number of");
		ttk_text(srf, ttk_menufont, 10, 30, ttk_ap_getx("window.fg")->color, "Live bullets: (out of six)");
		sprintf( buff, "%d bullets", livebullets );
		ttk_text(srf, ttk_menufont, 10, 50, ttk_ap_getx("window.fg")->color, buff);
		break;
	case PLAYERONE:
		if( players == PLAYERCPU ) {
			ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "Its your turn to spin!");
		} else {
			ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "Its Player One's");
			ttk_text(srf, ttk_menufont, 10, 30, ttk_ap_getx("window.fg")->color, "Turn to spin!");
		}
			ttk_text(srf, ttk_menufont, 10, 50, ttk_ap_getx("window.fg")->color, "Hit middle button to spin");
		break;
	case PLAYERTWO:
		if( players == PLAYERCPU ) {
			ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "Computer Spins!");
		} else {
			ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "Its Player Two's");
			ttk_text(srf, ttk_menufont, 10, 30, ttk_ap_getx("window.fg")->color, "Turn to spin!");	
			ttk_text(srf, ttk_menufont, 10, 50, ttk_ap_getx("window.fg")->color, "Hit middle button to spin");
		}
		break;
	case RESCLICK:
		ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "CLICK...");
		if( currentturn == 1 ) {
			if( players == PLAYERCPU ) {
				ttk_text(srf, ttk_menufont, 10, 30, ttk_ap_getx("window.fg")->color, "You go lucky!");
			} else {
				ttk_text(srf, ttk_menufont, 10, 30, ttk_ap_getx("window.fg")->color, "Player one got lucky!");
			}
		} else {
			if( players == PLAYERCPU ) {
				ttk_text(srf, ttk_menufont, 10, 30, ttk_ap_getx("window.fg")->color, "The CPU got lucky!");
			} else {
				ttk_text(srf, ttk_menufont, 10, 30, ttk_ap_getx("window.fg")->color, "Player two got lucky!");
			}
		}
		break;
	case RESBANG:
		ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "BANG!!!");
		break;
	case ENDRESULT:
		if( currentturn == 2 ) {
			if( players == PLAYERCPU ) {
				ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "You Win The Game!");
			} else {
				ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "Player One Wins!");
			}
		} else {
			if( players == PLAYERCPU ) {
				ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "You Lost The Game!");
			} else {
				ttk_text(srf, ttk_menufont, 10, 10, ttk_ap_getx("window.fg")->color, "Player Two Wins!");
			}
		}
		break;
	}
	
}

static void Init() 
{
  gamestate = PICKPLAYERS;
	players = PLAYERCPU;	
	livebullets = 1;

	srand(time(NULL)); 

}

static void ChangeSelection( int side ) 
{
  switch( gamestate ) {
	case PICKPLAYERS:
		if( 
			players == PLAYERCPU ) { players = PLAYERHUM;
 		} else { 
			players = PLAYERCPU; 
		}
		break;
	case PICKDANGER:
		if( (side == 0) && ((livebullets-1) > 0 ) ) livebullets--;
		if( (side == 1) && ((livebullets+1) < 6 ) ) livebullets++;
		break;
	case PLAYERONE:
		break;
	case PLAYERTWO:
		break;
	case RESCLICK:
		break;
	case RESBANG:
		break;
	case ENDRESULT:
		break;
	}

	wid->dirty++;

}

int Spin() 
{

	int rannum = rand()%60;

	/*printf( "ran = %d bul = %d \n", rannum, (livebullets*10) );
	CHECK randomness if u like */

	if( rannum < (livebullets*10)) return 0;

	return 1;
}

static void ConfirmSelection()
{
  switch( gamestate ) {
	case PICKPLAYERS:
		gamestate = PICKDANGER;
		break;
	case PICKDANGER:
		if( rand()%100 > 50 ) {
			gamestate = PLAYERONE;
		} else {
			gamestate = PLAYERTWO;
		}

		break;
	case PLAYERONE:
		currentturn = 1;
		if( Spin() == 0 ) {
			gamestate = RESBANG;
		} else {
			gamestate = RESCLICK;
		}
		break;
	case PLAYERTWO:
		currentturn = 2;
		if( Spin() == 0 ) {
			gamestate = RESBANG;
		} else {
			gamestate = RESCLICK;
		}
		break;
	case RESCLICK:
		if( currentturn == 2 ) {
			gamestate = PLAYERONE;
		} else {
			gamestate = PLAYERTWO;
		}
		break;
	case RESBANG:
		gamestate = ENDRESULT;
		break;
	case ENDRESULT:
		gamestate = PICKPLAYERS;
		break;
		
	}

	wid->dirty++;

}

static int event_rr(PzEvent *e)
{
   
   int ret = TTK_EV_CLICK;
   
   switch (e->type) {
    case PZ_EVENT_SCROLL:
     TTK_SCROLLMOD( e->arg, 5);
      if( e->arg > 0){ChangeSelection( 1 );}
      else {ChangeSelection( 0 );}
       wid->dirty++;
       break;

     case PZ_EVENT_BUTTON_DOWN:
       switch (e->arg) {
   
        case PZ_BUTTON_ACTION:
   ConfirmSelection();
   wid->dirty++;
        break;

      case PZ_BUTTON_MENU:
          pz_close_window(e->wid->win);
        break;}
   }
   return ret;
}

static PzWindow *new_rr_window()
{
     PzWindow *ret;
   
     w =ttk_screen->w;
     h =ttk_screen->h;

    ret = pz_new_window ("Russian Roulette", PZ_WINDOW_NORMAL);
    
    wid = pz_add_widget(ret, DrawWnd, event_rr);
    
    Init();

     pz_widget_set_timer(wid, 150);
    return pz_finish_window (ret);
}

static void cleanup_rr()
{
    ttk_free_surface(image);
}

static void init_rr()
{
    module = pz_register_module ("russianroulette", cleanup_rr);
    pz_menu_add_action ("/Extras/Games/Russian Roulette", new_rr_window);
   
}

PZ_MOD_INIT(init_rr) 
